Index: lib/style/skins/nceas/nceas.css
===================================================================
--- lib/style/skins/nceas/nceas.css	(revision 1981)
+++ lib/style/skins/nceas/nceas.css	(revision 1982)
@@ -235,3 +235,15 @@
     padding: 0px;
 }
 
+textarea {
+   width: 80%;
+}
+
+.required {
+    font-weight: bold;
+    color: red;
+}
+
+.label {
+    font-weight: bold;
+}
Index: lib/style/skins/obfs/obfs.css
===================================================================
--- lib/style/skins/obfs/obfs.css	(revision 1981)
+++ lib/style/skins/obfs/obfs.css	(revision 1982)
@@ -223,3 +223,15 @@
     padding: 0px;
 }
 
+textarea {
+   width: 80%;
+}
+
+.required {
+    font-weight: bold;
+    color: red;
+}
+
+.label {
+    font-weight: bold;
+}
Index: lib/style/common/templates/entryForm.tmpl
===================================================================
--- lib/style/common/templates/entryForm.tmpl	(revision 1981)
+++ lib/style/common/templates/entryForm.tmpl	(revision 1982)
@@ -1,5 +1,19 @@
 [% INCLUDE "genericHeader.tmpl" %]
 
+  <script language="JavaScript" type="text/javascript">
+    function addParagraph() {
+        var newParaWidget=document.createElement("textarea");
+        newParaWidget.setAttribute("rows", "5");
+        newParaWidget.setAttribute("columns", "80");
+        newParaWidget.setAttribute("name", "methodPara");
+        var newParaContainer = document.createElement("p");
+        newParaContainer.appendChild(newParaWidget);
+        var addParaButton = document.getElementById("addparabutton1");
+        var parent = addParaButton.parentNode;
+        parent.insertBefore(newParaContainer, addParaButton);
+    }
+  </script>
+
 [% IF cfg == 'nrs' %]
   [% lsite = 'reserve' %]
   [% usite = 'Reserve' %]
@@ -23,7 +37,7 @@
          inclusion in the registry.</p>
       <p>&nbsp;</p>
       <p>Please have a look at the 
-      <a href="@cgi-prefix@/register-dataset.cgi?cfg=[%cfg%]&stage=guide" target="guide">
+      <a href="@cgi-prefix@/register-dataset.cgi?cfg=[%cfg%]&amp;stage=guide" target="guide">
         <b>Guide on How to Complete Data Registry Entries</b></a> 
         before you start filling in this catalog form. Also, use your browser's 
         Reload/Refresh function to make sure you see the latest version of this 
@@ -31,7 +45,7 @@
       </p>
       <p>&nbsp;</p>
       <p align="left">Fields including a red asterisk 
-      (<b class="required">*</b>) are required.
+      (<span class="required">*</span>) are required.
       </p>
       <p>&nbsp;</p>
       <p align="left">If you have any questions, comments or problems 
@@ -42,13 +56,13 @@
       <p>Use this page to edit the data set description that you submitted earlier to the registry.</p>
       <p>&nbsp;</p>
       <p>Please have a look at the 
-      <a href="@cgi-prefix@/register-dataset.cgi?cfg=[%cfg%]&stage=guide" target="guide">
+      <a href="@cgi-prefix@/register-dataset.cgi?cfg=[%cfg%]&amp;stage=guide" target="guide">
         <b>Guide on How to Complete Data Registry Entries</b></a> 
         for help with filling of this catalog form.
       </p>
       <p>&nbsp;</p>
       <p align="left">Fields including a red asterisk 
-      (<b class="required">*</b>) are required.
+      (<span class="required">*</span>) are required.
       </p>
       <p>&nbsp;</p>
       <p align="left">If you have any questions, comments or problems 
@@ -66,29 +80,24 @@
   <input type="hidden" name="docid" value="[% docid %]">
   <input type="hidden" name="stage" value="insert">
   <p align="left">
-      <b><font size="-1" color="#0000ff">
-      <a href="@cgi-prefix@/register-dataset.cgi?cfg=[%cfg%]&stage=guide#BasicInformation" 
-         target="guide">BASIC INFORMATION </a>      </font>
-      </b>
+      <a href="@cgi-prefix@/register-dataset.cgi?cfg=[%cfg%]&amp;stage=guide#BasicInformation" target="guide">BASIC INFORMATION </a>
   </p>
   <table width="760" border="0" cellspacing="0" cellpadding="9"
 bgcolor="#c6d6e7">
     <tr> 
       <td> 
-        <p align="left"><font size="+1"> <font size="-2"> <font size="-1"> 
-          <b><font color="#ff0000">*</font>
-              Name of Person completing this form
-          </b></font>
-	</font></font></p>
-        <p><font size="-1"> 
+        <p align="left">
+          <span class="required">*</span><span class="label">Name of Person completing this form</span>
+	    </p>
+        <p>
           <input type="TEXT" name="providerGivenName" size="40" value="[%providerGivenName%]">
-          <b><font color="#ff0000">*</font>First Name</b></font></p>
-        <p><font size="-1"><b> 
+          <span class="required">*</span><span class="label">First Name</span></p>
+        <p>
           <input type="TEXT" name="providerSurName" size="40" value="[%providerSurName%]">
-          <font color="#ff0000">*</font>Last Name</b></font></p>
+          <span class="required">*</span><span class="label">Last Name</span></p>
 [% IF showSiteList == 'true' %]
-        <p align="left"> <font size="-1">
-          <select name="site" value="[%site%]">
+        <p align="left">
+          <select name="site">
 	    [% IF form == 're_entry' %]
 	    	<option selected>[%site%]</option>
 	    [% ELSE %]
@@ -98,12 +107,11 @@
               <option>[% site %]</option>
             [% END %]
           </select>
-          <b><font color="#ff0000">*</font>[% usite %] Name</b></font></p>
+          <span class="required">*</span><span class="label">[% usite %] Name</span></p>
 [% END %]
 [% IF cfg == 'nceas' %]
         <p align="left"> 
-          <b><font color="#ff0000">*</font>Working Group(s):</b></font></p>
-          <font size="-1">
+          <span class="required">*</span><span class="label">Working Group(s):</span></p>
           <select name="wg" multiple="multiple" size="5">
             [% FOREACH project = projects %]
               [% SET label = "${project.1}: $project.3 (NCEAS ${project.0})" %]
@@ -117,47 +125,25 @@
             [% END %]
           </select>
 [% END %]
-        <p align="left"><font size="-1"> 
+        <p align="left">
           <input type="TEXT" name="title" value="[%title%]" size="53">
-          <b><font color="#ff0000">*</font>Data Set Title</b></font></p>
+          <span class="required">*</span><span class="label">Data Set Title</span></p>
       </td>
     </tr>
   </table>
-  <p align="left"><b><font size="-1" color="#0000ff">
-
-      <a href="@cgi-prefix@/register-dataset.cgi?cfg=[%cfg%]&stage=guide#DataSetOriginator"
-         target="guide">DATA SET ORIGINATOR</a>
-	
-        </font></b>
+  <p align="left">
+      <a href="@cgi-prefix@/register-dataset.cgi?cfg=[%cfg%]&amp;stage=guide#DataSetOriginator" target="guide">DATA SET ORIGINATOR</a>
   </p>
   <table border="0" cellpadding="9" width="760" bgcolor="#c6d6e7"
 cellspacing="0">
     <tr> 
       <td valign="TOP" colspan="3"> 
-<!--        <p> <font size="-1">
-          <select name="origRole0">
-            <option> </option>
-	    <option selected>[%origRole0%]</option>
-            <option>Originator</option>
-            <option>Principal Investigator</option>
-            <option>Editor</option>
-            <option>Publisher</option>
-            <option>Processor</option>
-            <option>Custodian/Steward</option>
-            <option>Author</option>
-            <option>Content Provider</option>
-            <option>Distributor</option>
-            <option>Metadata Provider</option>
-            <option>Owner</option>
-          </select>
-          <b>Originator's Role (</b>Leave this field empty unless you desire to 
-          be more specific)</font></p> -->
-        <p><font size="-1"> 
+        <p>
           <input type="TEXT" name="origNamefirst0" size="40" value="[%origNamefirst0%]">
-          <b><font color="#ff0000">*</font>First Name</b></font></p>
-        <p><font size="-1"><b> 
+          <span class="required">*</span><span class="label">First Name</span></p>
+        <p>
           <input type="TEXT" name="origNamelast0" size="40" value="[%origNamelast0%]">
-          <font color="#ff0000">*</font>Last Name</b></font></p>
+          <span class="required">*</span><span class="label">Last Name</span></p>
         <p><font size="-1"> 
           <input type="TEXT" name="origNameOrg" size="60" value="[%origNameOrg%]">
           <b>Organization Name</b></font></p>
@@ -262,7 +248,7 @@
   </table>
   <p><b><font size="-1" color="#0000ff">
       <a 
-       href="@cgi-prefix@/register-dataset.cgi?cfg=[%cfg%]&stage=guide#AdditionalOriginators"
+       href="@cgi-prefix@/register-dataset.cgi?cfg=[%cfg%]&amp;stage=guide#AdditionalOriginators"
        target="guide">ADDITIONAL ORIGINATORS</a>
 	</font></b>
   </p>
@@ -612,7 +598,7 @@
   </table>
   <br>
   <p align="left"><font size="4" color="0000ff"><b><font size="-1">
-       <a href="@cgi-prefix@/register-dataset.cgi?cfg=[%cfg%]&stage=guide#DataSetAbstract"
+       <a href="@cgi-prefix@/register-dataset.cgi?cfg=[%cfg%]&amp;stage=guide#DataSetAbstract"
           target="guide">DATA SET ABSTRACT</a>
 	</font></b></font> 
 
@@ -630,7 +616,7 @@
   </table>
   <p align="left"><font size="4" color="0000ff"><b><font size="-1">
        <a 
-        href="@cgi-prefix@/register-dataset.cgi?cfg=[%cfg%]&stage=guide#KeywordInformation"
+        href="@cgi-prefix@/register-dataset.cgi?cfg=[%cfg%]&amp;stage=guide#KeywordInformation"
         target="guide">KEYWORD INFORMATION</a>
 	</font></b></font> 
     <font size="-1"><b><br>
@@ -984,7 +970,7 @@
   <br>
   <p align="left"><font size="4" color="0000ff"><b><font size="-1">
   <a
-   href="@cgi-prefix@/register-dataset.cgi?cfg=[%cfg%]&stage=guide#TemporalCoverageOfData"
+   href="@cgi-prefix@/register-dataset.cgi?cfg=[%cfg%]&amp;stage=guide#TemporalCoverageOfData"
    target="guide">TEMPORAL COVERAGE OF DATA</a>
 	</font></b></font> 
   <table cellspacing="0" border="0" cellpadding="9" width="760"
@@ -1038,7 +1024,7 @@
   <br>
   <p align="left"><font size="4" color="0000ff"><b><font size="-1">
   <a
-   href="@cgi-prefix@/register-dataset.cgi?cfg=[%cfg%]&stage=guide#SpatialCoverageOfData"
+   href="@cgi-prefix@/register-dataset.cgi?cfg=[%cfg%]&amp;stage=guide#SpatialCoverageOfData"
    target="guide">SPATIAL COVERAGE OF DATA</a>
 	</font></b></font> 
   <table cellspacing="0" border="0" cellpadding="9" width="760"
@@ -1103,7 +1089,7 @@
       </td>
       <td width="20%" valign="TOP"> 
         <p><font size="-1"> 
-          <input type="TEXT" name="longDeg1" value="[%longDeg1%]" size="3": maxlength="3">
+          <input type="TEXT" name="longDeg1" value="[%longDeg1%]" size="3" maxlength="3">
           <input type="TEXT" name="longMin1" value="[%longMin1%]" size="2" maxlength="2">
           <input type="TEXT" name="longSec1" value="[%longSec1%]" size="2" maxlength="2">
           </font></p>
@@ -1179,9 +1165,45 @@
       </td>
     </tr>
   </table>
+
+  [% IF cfg == 'nceas' %]
+  <a href="@cgi-prefix@/register-dataset.cgi?cfg=[%cfg%]&amp;stage=guide#Methods" target="guide">METHODS</a>
+  <table cellspacing="0" border="0" cellpadding="9" width="760" bgcolor="#c6d6e7">
+    <tbody>
+    <tr> 
+      <td valign="top" colspan="3"> 
+        <p class="label">Data Collection Methods</p>
+      </td>
+    </tr>
+    <tr> 
+      <td valign="top"> 
+        <p>
+          <input type="text" name="methodTitle" value="[%methodTitle%]" size="40">
+          <span class="label">Title of Method</span>
+        </p>
+        <p>
+          <span class="label">Method Description</span>
+        [% IF methodPara.size < 1 %]
+          <br>
+          <textarea rows="5" cols="80" name="methodPara"></textarea>
+        [% END %]
+        [% FOREACH para = methodPara %]
+          <br>
+          <textarea rows="5" cols="80" name="methodPara">[% para %]</textarea>
+        [% END %]
+        </p>
+        <p>
+          <input type="button" value="Add paragraph" id="addparabutton1"
+                 onClick="addParagraph()">
+        </p>
+      </td>
+     </tbody>
+   </table>
+  [% END %]
+
   <p><b><font size="-1" color="#0000ff">
   <a
-   href="@cgi-prefix@/register-dataset.cgi?cfg=[%cfg%]&stage=guide#DataSetContactAddress"
+   href="@cgi-prefix@/register-dataset.cgi?cfg=[%cfg%]&amp;stage=guide#DataSetContactAddress"
    target="guide">DATA SET CONTACT ADDRESS</a>
 	</font></b></p>
   <table border="0" cellspacing="0" cellpadding="9" width="760" bgcolor="#c6d6e7">
@@ -1224,81 +1246,69 @@
         <p> 
           <select name="origStateContact">
 	    [% IF form == 're_entry' %]	
-            	<option><font size="-1" face="Arial, Helvetica, sans-serif">[%origStateContact%]</font></option>
+            	<option>[%origStateContact%]</option>
 	    [% ELSE %]
-                <option><font size="-1" face="Arial, Helvetica, sans-serif">Select state here.</font></option>
+                <option>Select state here.</option>
             [% END %]
-	    <option><font size="-1" face="Arial, Helvetica, sans-serif">Alabama</font></option>
-            <option><font size="-1" face="Arial, Helvetica, sans-serif">Alaska</font></option>
-            <option><font size="-1" face="Arial, Helvetica, sans-serif">American 
-            Samoa</font></option>
-            <option><font size="-1" face="Arial, Helvetica, sans-serif">Arizona</font></option>
-            <option><font size="-1" face="Arial, Helvetica, sans-serif">Arkansas</font></option>
-            <option><font size="-1" face="Arial, Helvetica, sans-serif">California</font></option>
-            <option><font size="-1" face="Arial, Helvetica, sans-serif">Colorado</font></option>
-            <option><font size="-1" face="Arial, Helvetica, sans-serif">Connecticut</font></option>
-            <option><font size="-1" face="Arial, Helvetica, sans-serif">Delaware</font></option>
-            <option><font size="-1" face="Arial, Helvetica, sans-serif">District 
-            of Columbia</font></option>
-            <option><font size="-1" face="Arial, Helvetica, sans-serif">Federated 
-            States of Micronesia</font></option>
-            <option><font size="-1" face="Arial, Helvetica, sans-serif">Florida</font></option>
-            <option><font size="-1" face="Arial, Helvetica, sans-serif">Georgia</font></option>
-            <option><font size="-1" face="Arial, Helvetica, sans-serif">Guam</font></option>
-            <option><font size="-1" face="Arial, Helvetica, sans-serif">Hawaii</font></option>
-            <option><font size="-1" face="Arial, Helvetica, sans-serif">Idaho</font></option>
-            <option><font size="-1" face="Arial, Helvetica, sans-serif">Illinois</font></option>
-            <option><font size="-1" face="Arial, Helvetica, sans-serif">Indiana</font></option>
-            <option><font size="-1" face="Arial, Helvetica, sans-serif">Iowa</font></option>
-            <option><font size="-1" face="Arial, Helvetica, sans-serif">Kansas</font></option>
-            <option><font size="-1" face="Arial, Helvetica, sans-serif">Kentucky</font></option>
-            <option><font size="-1" face="Arial, Helvetica, sans-serif">Louisiana</font></option>
-            <option><font size="-1" face="Arial, Helvetica, sans-serif">Maine</font></option>
-            <option><font size="-1" face="Arial, Helvetica, sans-serif">Marshall 
-            Islands</font></option>
-            <option><font size="-1" face="Arial, Helvetica, sans-serif">Maryland</font></option>
-            <option><font size="-1" face="Arial, Helvetica, sans-serif">Massachusetts</font></option>
-            <option><font size="-1" face="Arial, Helvetica, sans-serif">Michigan</font></option>
-            <option><font size="-1" face="Arial, Helvetica, sans-serif">Minnesota</font></option>
-            <option><font size="-1" face="Arial, Helvetica, sans-serif">Mississippi</font></option>
-            <option><font size="-1" face="Arial, Helvetica, sans-serif">Missouri</font></option>
-            <option><font size="-1" face="Arial, Helvetica, sans-serif">Montana</font></option>
-            <option><font size="-1" face="Arial, Helvetica, sans-serif">Nebraska</font></option>
-            <option><font size="-1" face="Arial, Helvetica, sans-serif">Nevada</font></option>
-            <option><font size="-1" face="Arial, Helvetica, sans-serif">New Hampshire</font></option>
-            <option><font size="-1" face="Arial, Helvetica, sans-serif">New Jersey</font></option>
-            <option><font size="-1" face="Arial, Helvetica, sans-serif">New Mexico</font></option>
-            <option><font size="-1" face="Arial, Helvetica, sans-serif">New York</font></option>
-            <option><font size="-1" face="Arial, Helvetica, sans-serif">North 
-            Carolina</font></option>
-            <option><font size="-1" face="Arial, Helvetica, sans-serif">North 
-            Dakota</font></option>
-            <option><font size="-1" face="Arial, Helvetica, sans-serif">Northern 
-            Mariana Islands</font></option>
-            <option><font size="-1" face="Arial, Helvetica, sans-serif">Ohio</font></option>
-            <option><font size="-1" face="Arial, Helvetica, sans-serif">Oklahoma</font></option>
-            <option><font size="-1" face="Arial, Helvetica, sans-serif">Oregon</font></option>
-            <option><font size="-1" face="Arial, Helvetica, sans-serif">Palau</font></option>
-            <option><font size="-1" face="Arial, Helvetica, sans-serif">Pennsylvania</font></option>
-            <option><font size="-1" face="Arial, Helvetica, sans-serif">Puerto 
-            Rico</font></option>
-            <option><font size="-1" face="Arial, Helvetica, sans-serif">Rhode 
-            Island</font></option>
-            <option><font size="-1" face="Arial, Helvetica, sans-serif">South 
-            Carolina</font></option>
-            <option><font size="-1" face="Arial, Helvetica, sans-serif">South 
-            Dakota</font></option>
-            <option><font size="-1" face="Arial, Helvetica, sans-serif">Tennessee</font></option>
-            <option><font size="-1" face="Arial, Helvetica, sans-serif">Texas</font></option>
-            <option><font size="-1" face="Arial, Helvetica, sans-serif">Utah</font></option>
-            <option><font size="-1" face="Arial, Helvetica, sans-serif">Vermont</font></option>
-            <option><font size="-1" face="Arial, Helvetica, sans-serif">Virgin 
-            Islands</font></option>
-            <option><font size="-1" face="Arial, Helvetica, sans-serif">Virginia</font></option>
-            <option><font size="-1" face="Arial, Helvetica, sans-serif">Washington</font></option>
-            <option><font size="-1" face="Arial, Helvetica, sans-serif">West Virginia</font></option>
-            <option><font size="-1" face="Arial, Helvetica, sans-serif">Wisconsin</font></option>
-            <option><font size="-1" face="Arial, Helvetica, sans-serif">Wyoming</font></option>
+	        <option>Alabama</option>
+            <option>Alaska</option>
+            <option>American Samoa</option>
+            <option>Arizona</option>
+            <option>Arkansas</option>
+            <option>California</option>
+            <option>Colorado</option>
+            <option>Connecticut</option>
+            <option>Delaware</option>
+            <option>District of Columbia</option>
+            <option>Federated States of Micronesia</option>
+            <option>Florida</option>
+            <option>Georgia</option>
+            <option>Guam</option>
+            <option>Hawaii</option>
+            <option>Idaho</option>
+            <option>Illinois</option>
+            <option>Indiana</option>
+            <option>Iowa</option>
+            <option>Kansas</option>
+            <option>Kentucky</option>
+            <option>Louisiana</option>
+            <option>Maine</option>
+            <option>Marshall Islands</option>
+            <option>Maryland</option>
+            <option>Massachusetts</option>
+            <option>Michigan</option>
+            <option>Minnesota</option>
+            <option>Mississippi</option>
+            <option>Missouri</option>
+            <option>Montana</option>
+            <option>Nebraska</option>
+            <option>Nevada</option>
+            <option>New Hampshire</option>
+            <option>New Jersey</option>
+            <option>New Mexico</option>
+            <option>New York</option>
+            <option>North Carolina</option>
+            <option>North Dakota</option>
+            <option>Northern Mariana Islands</option>
+            <option>Ohio</option>
+            <option>Oklahoma</option>
+            <option>Oregon</option>
+            <option>Palau</option>
+            <option>Pennsylvania</option>
+            <option>Puerto Rico</option>
+            <option>Rhode Island</option>
+            <option>South Carolina</option>
+            <option>South Dakota</option>
+            <option>Tennessee</option>
+            <option>Texas</option>
+            <option>Utah</option>
+            <option>Vermont</option>
+            <option>Virgin Islands</option>
+            <option>Virginia</option>
+            <option>Washington</option>
+            <option>West Virginia</option>
+            <option>Wisconsin</option>
+            <option>Wyoming</option>
           </select>
           <b><font size="-1">State</font></b>&nbsp;&nbsp;&nbsp;
           <font size="-1"> 
@@ -1317,7 +1327,7 @@
   <br>
   <p align="left"><font size="4" color="0000ff"><b><font size="-1">
   <a
-   href="@cgi-prefix@/register-dataset.cgi?cfg=[%cfg%]&stage=guide#DistributionIinformation"
+   href="@cgi-prefix@/register-dataset.cgi?cfg=[%cfg%]&amp;stage=guide#DistributionIinformation"
    target="guide">DISTRIBUTION INFORMATION</a>
 	</font></b></font> 
   <table cellspacing="0" border="0" cellpadding="9" width="760"
@@ -1329,7 +1339,7 @@
         <p align="left"><font size="-1"> 
           <input type="TEXT" name="identifier" value="[%identifier%]" size="40">
   <b><a
-   href="@cgi-prefix@/register-dataset.cgi?cfg=[%cfg%]&stage=guide#Site-specificCode"
+   href="@cgi-prefix@/register-dataset.cgi?cfg=[%cfg%]&amp;stage=guide#Site-specificCode"
    target="guide">Dataset Name or Identifier (important)</a> </b></font></p>
 
         <p><font size="-1"><b><font color="#ff0000">*</font>Data Medium:</b></font></p>
@@ -1390,7 +1400,7 @@
 
         <p align="left"><font size="-1"><b>
   <a
-   href="@cgi-prefix@/register-dataset.cgi?cfg=[%cfg%]&stage=guide#AdditionalInformation"
+   href="@cgi-prefix@/register-dataset.cgi?cfg=[%cfg%]&amp;stage=guide#AdditionalInformation"
    target="guide">Additional Information/Remarks:</a>	
 	</b></font></p>
         <p align="left"><font size="-1"> 
Index: lib/style/common/templates/genericHeader.tmpl
===================================================================
--- lib/style/common/templates/genericHeader.tmpl	(revision 1981)
+++ lib/style/common/templates/genericHeader.tmpl	(revision 1982)
@@ -22,12 +22,12 @@
   -->
 <!--____________________________max_width_____________________________________-->
 
-<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
+<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
 <html>
 <head>
   <title>[% orgabbrev %] Data Registry</title>
   <link rel="stylesheet" type="text/css" 
-        href="@systemidserver@@style-skins-path@/[%cfg%]/[%cfg%].css"></link>
+        href="@systemidserver@@style-skins-path@/[%cfg%]/[%cfg%].css">
   <script language="JavaScript" type="text/JavaScript"
           src="@systemidserver@@style-skins-path@/[%cfg%]/[%cfg%].js"></script>
   <script language="JavaScript" type="text/JavaScript"
@@ -35,6 +35,6 @@
 </head>
 
 <body>
-      <script language="JavaScript">
+      <script language="JavaScript" type="text/javascript">
           insertTemplateOpening();
       </script>
Index: lib/style/common/templates/confirmData.tmpl
===================================================================
--- lib/style/common/templates/confirmData.tmpl	(revision 1981)
+++ lib/style/common/templates/confirmData.tmpl	(revision 1982)
@@ -480,6 +480,15 @@
   </table>
 
 
+[% IF cfg == 'nceas' %]
+    <hr>
+    <a name="Methods"></a>
+    <p><b><font size="-1">Mthod Title:</font></b>  [%methodTitle%]</p>
+    [% FOREACH para = methodPara %]
+        <p><b><font size="-1">Paragraph:</font></b>  [%para%] </p>
+    [% END %]
+[% END %]
+
 <hr>
 <a name="DataSetContactAddress"></a>
 <p><b><font size="4" color="#0000ff">DATA SET CONTACT ADDRESS</font></b> 
@@ -681,6 +690,12 @@
   <input type="hidden" name="longMin2" value="[%longMin2%]">
   <input type="hidden" name="longSec2" value="[%longSec2%]">
   <input type="hidden" name="hemisphLong2" value="[%hemisphLong2%]">
+  [% IF cfg == 'nceas' %]
+      <input type="hidden" name="methodTitle" value="[%methodTitle%]">
+      [% FOREACH para = methodPara %]
+          <input type="hidden" name="methodPara" value="[%para%]">
+      [% END %]
+  [% END %]
 <table cellspacing="0" border="0" cellpadding="9" width="800" bgcolor="#C6d6e7">
   <tr> 
     <td> 
Index: lib/style/common/templates/genericFooter.tmpl
===================================================================
--- lib/style/common/templates/genericFooter.tmpl	(revision 1981)
+++ lib/style/common/templates/genericFooter.tmpl	(revision 1982)
@@ -1,4 +1,4 @@
-<script language="JavaScript">          
+<script language="JavaScript" type="text/javascript">
     insertTemplateClosing();
 </script>
 </body>
Index: src/perl/register-dataset.cgi
===================================================================
--- src/perl/register-dataset.cgi	(revision 1981)
+++ src/perl/register-dataset.cgi	(revision 1982)
@@ -308,7 +308,7 @@
         push(@errorMessages, "Failed during login.\n");
     }
 
-debug( "Registry: A");
+    debug( "Registry: A");
     if ($FORM::docid eq "") {
         debug( "Registry: B1");
         # document is being inserted 
@@ -318,7 +318,7 @@
             
             $xmldoc =~ s/docid/$docid/;
     
-            #my $testFile = "/usr/local/apache2/htdocs/xml/test.xml";
+            #my $testFile = "/tmp/test.xml";
             #open (TFILE,">$testFile") || die ("Cant open xml file...\n");
             #print TFILE $xmldoc;
             #close(TFILE);
@@ -1158,6 +1158,18 @@
 
     $doc .= $cont;
     $doc .= $publ;
+    
+    if ((hasContent($FORM::methodTitle)) || scalar(@FORM::methodsPara) > 0) {
+        my $methods = "<methods><methodStep><description><section>\n";
+        if (hasContent($FORM::methodTitle)) {
+            $methods .= "<title>$FORM::methodTitle</title>\n";
+        }
+        for (my $i = 0; $i < scalar(@FORM::methodPara); $i++) {
+            $methods .= "<para>$FORM::methodPara[$i]</para>\n";
+        }
+        $methods .= "</section></description></methodStep></methods>\n";
+        $doc .= $methods;
+    }
 
     $doc .= "<access authSystem=\"knb\" order=\"denyFirst\">\n";
     $doc .= "<allow>\n";
@@ -1856,8 +1868,43 @@
         }
     }
     
+    $results = $doc->findnodes('//dataset/methods/methodStep/description/section');
+    debug("Registry: Number methods: ".$results->size());
+    if ($results->size() > 1) {
+        errMoreThanN("methods/methodStep/description/section");    
+    } else {
+        dontOccur($doc, "//methodStep/citation", "methodStep/citation");
+        dontOccur($doc, "//methodStep/protocol", "methodStep/protocol");
+        dontOccur($doc, "//methodStep/instrumentation", "methodStep/instrumentation");
+        dontOccur($doc, "//methodStep/software", "methodStep/software");
+        dontOccur($doc, "//methodStep/subStep", "methodStep/subStep");
+        dontOccur($doc, "//methodStep/dataSource", "methodStep/dataSource");
+        dontOccur($doc, "//methods/sampling", "methods/sampling");
+        dontOccur($doc, "//methods/qualityControl", "methods/qualityControl");
+
+        my @methodPara;
+        foreach $node ($results->get_nodelist) {
+            my @children = $node->childNodes;
+            for (my $i = 0; $i < scalar(@children); $i++) {
+                debug("Registry: Method child loop ($i)");
+                my $child = $children[$i];
+                if ($child->nodeName eq 'title') {
+                    my $title = $child->textContent();
+                    debug("Registry: Method title ($title)");
+                    $$templateVars{'methodTitle'} = $title;
+                } elsif ($child->nodeName eq 'para') {
+                    my $para = $child->textContent();
+                    debug("Registry: Method para ($para)");
+                    $methodPara[scalar(@methodPara)] = $para;
+                }
+            }
+        }
+        if (scalar(@methodPara) > 0) {
+            $$templateVars{'methodPara'} = \@methodPara;
+        }
+    }
+
     dontOccur($doc, "./pubPlace", "pubPlace");
-    dontOccur($doc, "./methods", "methods");
     dontOccur($doc, "./project", "project");
     
     dontOccur($doc, "./dataTable", "dataTable");
@@ -2219,6 +2266,8 @@
     $$templateVars{'longMin2'} = $FORM::longMin2;
     $$templateVars{'longSec2'} = $FORM::longSec2;
     $$templateVars{'hemisphLong2'} = $FORM::hemisphLong2;
+    $$templateVars{'methodTitle'} = $FORM::methodTitle;
+    $$templateVars{'methodPara'} = \@FORM::methodPara;
     $$templateVars{'docid'} = $FORM::docid;
 
     $$templateVars{'section'} = "Confirm Data";
@@ -2256,7 +2305,7 @@
     $$templateVars{'providerGivenName'} = $FORM::providerGivenName;
     $$templateVars{'providerSurName'} = $FORM::providerSurName;
     $$templateVars{'site'} = $FORM::site;
-    if($FORM::cfg eq "nceas"){
+    if ($FORM::cfg eq "nceas") {
         my $projects = getProjectList();
         $$templateVars{'projects'} = $projects;
         $$templateVars{'wg'} = \@FORM::wg;
@@ -2387,6 +2436,10 @@
     $$templateVars{'longMin2'} = $FORM::longMin2;
     $$templateVars{'longSec2'} = $FORM::longSec2;
     $$templateVars{'hemisphLong2'} = $FORM::hemisphLong2;
+    if ($FORM::cfg eq "nceas") {
+        $$templateVars{'methodsTitle'} = $FORM::methodsTitle;
+        $$templateVars{'methodsPara'} = \@FORM::methodsPara;
+    }
     $$templateVars{'docid'} = $FORM::docid;
 
     $$templateVars{'form'} = 're_entry';