Index: lib/style/skins/knb/knb.css
===================================================================
--- lib/style/skins/knb/knb.css	(revision 2037)
+++ lib/style/skins/knb/knb.css	(revision 2038)
@@ -196,3 +196,31 @@
 .searchresultsdivider {
     background-color: #dddddd;   
 }
+
+/**
+ *  these are used only in the registry skins
+ */
+p.searchbox {
+    color: #0040A1;
+    font-weight: bold;
+    font-size: 12px; 
+    text-decoration: none; 
+}
+
+br {
+    margin: 0px;
+    padding: 0px;
+}
+
+textarea {
+   width: 80%;
+}
+
+.required {
+    font-weight: bold;
+    color: red;
+}
+
+.label {
+    font-weight: bold;
+}
Index: lib/style/skins/knb/knb.cfg
===================================================================
--- lib/style/skins/knb/knb.cfg	(nonexistent)
+++ lib/style/skins/knb/knb.cfg	(revision 2038)
@@ -0,0 +1,28 @@
+#
+# General configuration parameters
+#
+metacatUrl = http://@server@@servlet-path@
+username = uid=knbadmin,o=NCEAS,dc=ecoinformatics,dc=org
+password = your-pw-goes-here
+ldapUrl=@ldapUrl@
+defaultScope = knb
+organization = Knowledge Network for Biocomplexity
+orgabbrev = KNB
+orgurl = http://knb.ecoinformatics.org/
+responseTemplate = @responseForm@
+entryFormTemplate = @entryForm@
+guideTemplate = @guide@
+confirmDataTemplate = @confirmData@
+deleteDataTemplate = @deleteData@
+accesspubid = -//ecoinformatics.org//eml-access-2.0.0beta6//EN
+accesssysid = eml-access.dtd
+datasetpubid = eml://ecoinformatics.org/eml-dataset-2.0.0
+datasetsysid = eml-dataset.dtd
+mailhost = hyperion.nceas.ucsb.edu
+sender = KNB Data Registry <help@nceas.ucsb.edu>
+recipient = help@nceas.ucsb.edu
+adminname = the repository administrator
+debug = 1
+nceas_db = somedb
+nceas_db_user = someuser
+nceas_db_password = your-pw-goes-here

Property changes on: lib/style/skins/knb/knb.cfg
___________________________________________________________________
Added: svn:eol-style
## -0,0 +1 ##
+native
\ No newline at end of property
Added: svn:executable
## -0,0 +1 ##
+*
\ No newline at end of property
Added: svn:keywords
## -0,0 +1 ##
+Author Date Id Revision
\ No newline at end of property
Index: lib/style/common/templates/entryForm.tmpl
===================================================================
--- lib/style/common/templates/entryForm.tmpl	(revision 2037)
+++ lib/style/common/templates/entryForm.tmpl	(revision 2038)
@@ -310,6 +310,7 @@
           </select>
           <span class="required">*</span><span class="label">[% usite %] Name</span></p>
 [% END %]
+        <p align="left">&nbsp;</p>
         <p align="left">
           <input type="TEXT" name="title" value="[%title%]" size="53">
           <span class="required">*</span><span class="label">Data Set Title</span></p>
@@ -334,6 +335,12 @@
             [% END %]
           </select>
 [% END %]
+[% IF cfg == 'knb' %]
+        <p align="left">
+          <input type="TEXT" name="site" size="40" value="[%site%]">
+          <span class="required">*</span><span class="label">Organization Name</span>
+        </p>
+[% END %]
       </td>
     </tr>
   </table>
Index: lib/style/common/templates/confirmData.tmpl
===================================================================
--- lib/style/common/templates/confirmData.tmpl	(revision 2037)
+++ lib/style/common/templates/confirmData.tmpl	(revision 2038)
@@ -636,7 +636,7 @@
       If you don't remember your password, you can
       have it reset and emailed to you <a target="ldap"
       href="@cgi-prefix@/ldapweb.cgi?stage=resetpass&cfg=[% cfg %]">here.
-      </a> If you want to change your password, click here <a target="ldap"
+      </a> If you want to change your password, click <a target="ldap"
       href="@cgi-prefix@/ldapweb.cgi?stage=changepass&cfg=[% cfg %]">here.
       </a></font>
       <table cellspacing="0" border="0" cellpadding="9" width="360" bgcolor="#C6d6e7" align="left">
Index: src/perl/register-dataset.cgi
===================================================================
--- src/perl/register-dataset.cgi	(revision 2037)
+++ src/perl/register-dataset.cgi	(revision 2038)
@@ -1269,14 +1269,16 @@
             $creat .= "</creator>\n";
         }
     } else {
-	$creat .= "<creator>\n";
-	$creat .= "<organizationName>".normalize($FORM::site)."</organizationName>\n";
-	$creat .= "</creator>\n";
+	    $creat .= "<creator>\n";
+	    $creat .= "<organizationName>".normalize($FORM::site)."</organizationName>\n";
+	    $creat .= "</creator>\n";
     }
 
-    $creat .= "<creator>\n";
-    $creat .= "<organizationName>".normalize($organization)."</organizationName>\n";
-    $creat .= "</creator>\n";
+    if ($FORM::cfg ne 'knb') {
+        $creat .= "<creator>\n";
+        $creat .= "<organizationName>".normalize($organization)."</organizationName>\n";
+        $creat .= "</creator>\n";
+    }
 
     $doc .= $creat;
     $doc .= $metaP;